/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreValuelistDeDeRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreValuelistDeDe extends TableImpl<VCoreValuelistDeDeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_valuelist_de_de</code>
     */
    public static final VCoreValuelistDeDe V_CORE_VALUELIST_DE_DE = new VCoreValuelistDeDe();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreValuelistDeDeRecord> getRecordType() {
        return VCoreValuelistDeDeRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_valuelist_de_de.valuelist</code>.
     */
    public final TableField<VCoreValuelistDeDeRecord, Integer> VALUELIST = createField(DSL.name("valuelist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_de_de.key</code>.
     */
    public final TableField<VCoreValuelistDeDeRecord, String> KEY = createField(DSL.name("key"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_de_de.pk_lang</code>.
     */
    public final TableField<VCoreValuelistDeDeRecord, JSONB> PK_LANG = createField(DSL.name("pk_lang"), SQLDataType.JSONB, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_de_de.value</code>.
     */
    public final TableField<VCoreValuelistDeDeRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_de_de.globallist</code>.
     */
    public final TableField<VCoreValuelistDeDeRecord, Boolean> GLOBALLIST = createField(DSL.name("globallist"), SQLDataType.BOOLEAN, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_de_de.changeable</code>.
     */
    public final TableField<VCoreValuelistDeDeRecord, Boolean> CHANGEABLE = createField(DSL.name("changeable"), SQLDataType.BOOLEAN, this, "");

    private VCoreValuelistDeDe(Name alias, Table<VCoreValuelistDeDeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreValuelistDeDe(Name alias, Table<VCoreValuelistDeDeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_valuelist_de_de" as  SELECT t_core_valuelist.valuelist,
          json_data.key,
          json_data.value AS pk_lang,
          t.value,
          t_core_valuelist.globallist,
          t_core_valuelist.changeable
         FROM common_dd.t_core_valuelist,
          (LATERAL jsonb_each(t_core_valuelist."values") json_data(key, value)
           LEFT JOIN common_dd.t_core_translation t ON ((t.fk_trans_key = (json_data.value)::text)))
        WHERE ((t_core_valuelist.fk_valuetype = 1) AND (t.isocode = 'de_DE'::common_dd.enum_isocode));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_valuelist_de_de</code> table
     * reference
     */
    public VCoreValuelistDeDe(String alias) {
        this(DSL.name(alias), V_CORE_VALUELIST_DE_DE);
    }

    /**
     * Create an aliased <code>common_dd.v_core_valuelist_de_de</code> table
     * reference
     */
    public VCoreValuelistDeDe(Name alias) {
        this(alias, V_CORE_VALUELIST_DE_DE);
    }

    /**
     * Create a <code>common_dd.v_core_valuelist_de_de</code> table reference
     */
    public VCoreValuelistDeDe() {
        this(DSL.name("v_core_valuelist_de_de"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreValuelistDeDe as(String alias) {
        return new VCoreValuelistDeDe(DSL.name(alias), this);
    }

    @Override
    public VCoreValuelistDeDe as(Name alias) {
        return new VCoreValuelistDeDe(alias, this);
    }

    @Override
    public VCoreValuelistDeDe as(Table<?> alias) {
        return new VCoreValuelistDeDe(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistDeDe rename(String name) {
        return new VCoreValuelistDeDe(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistDeDe rename(Name name) {
        return new VCoreValuelistDeDe(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistDeDe rename(Table<?> name) {
        return new VCoreValuelistDeDe(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistDeDe where(Condition condition) {
        return new VCoreValuelistDeDe(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistDeDe where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistDeDe where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistDeDe where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistDeDe where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistDeDe where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistDeDe where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistDeDe where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistDeDe whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistDeDe whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
